import type { RobotInfo } from '@api/robot';
import type { Pen } from '@meta2d/core';

import type { MapAreaType, MapPointType, MapRouteType } from './constant';

export interface MapPen extends Pen {
  label?: string; // 展示名称
  desc?: string; // 描述

  point?: MapPointInfo; // 点位信息
  route?: MapRouteInfo; // 线路信息
  area?: MapAreaInfo; // 区域信息

  attrs?: Record<string, unknown>; // 额外属性
  activeAttrs?: string[]; // 已激活的额外属性
}

//#region 点位
export interface MapPointInfo {
  type: MapPointType; // 点位类型
  robots?: RobotInfo['id'][]; // 绑定机器人id集合
}
//#endregion

//#region 线路
export interface MapRouteInfo {
  type: MapRouteType; // 线路类型
  direction?: -1 | 1; // 线路方向
}
//#endregion

//#region 区域
export interface MapAreaInfo {
  type: MapAreaType; // 区域类型
  points?: string[]; // 绑定点位id集合
  routes?: string[]; // 绑定线路id集合
}
//#endregion
